<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>18.2.1: Bitwise Operators</title>
<link href="sx4b.html" rev=precedes>
<link href="sx4bb.html" rel=precedes>
<link href="sx4b.html" rev=subdocument>
</head>
<body>
<H3>18.2.1: Bitwise Operators</H3>

<p>[This section corresponds to K&amp;R Sec. 2.9]
</p><p>The bitwise operators operate on numbers
(always integers)
as if they were
sequences
of binary bits
(which, of course, internally to the computer they
are).
These operators will make the most sense,
therefore,
if we consider integers as represented in binary, octal, or hexadecimal
(bases 2, 8, or 16),
not decimal (base 10).
Remember,

you can use octal constants in C
by prefixing them with an extra <TT>0</TT> (zero),
and you can use hexadecimal constants
by prefixing them with <TT>0x</TT>
(or <TT>0X</TT>).
</p><p>The <TT>&amp;</TT> operator
performs a bitwise AND on two integers.
Each bit in the result is 1 only if
both corresponding bits in the two input operands are 1.
For example, <TT>0x56 &amp; 0x32</TT> is <TT>0x12</TT>,
because (in binary):
<pre>
	  0 1 0 1 0 1 1 0
	&amp; 0 0 1 1 0 0 1 0
	  ---------------
	  0 0 0 1 0 0 1 0
</pre>
</p><p>The <TT>|</TT> (vertical bar) operator
performs a bitwise OR on two integers.
Each bit in the result is 1 if
either of the corresponding bits in the two input operands is 1.
For example, <TT>0x56 | 0x32</TT> is <TT>0x76</TT>,
because:
<pre>
	  0 1 0 1 0 1 1 0
	| 0 0 1 1 0 0 1 0
	  ---------------
	  0 1 1 1 0 1 1 0
</pre>
</p><p>The <TT>^</TT> (caret) operator
performs a bitwise exclusive-OR on two integers.
Each bit in the result is 1 if
one, but not both,
of the corresponding bits in the two input operands is 1.
For example, <TT>0x56 ^ 0x32</TT> is <TT>0x64</TT>:
<pre>
	  0 1 0 1 0 1 1 0
	^ 0 0 1 1 0 0 1 0
	  ---------------
	  0 1 1 0 0 1 0 0
</pre>
</p><p>The <TT>~</TT> (tilde) operator
performs a bitwise complement on its single integer operand.
(The <TT>~</TT> operator is therefore a unary operator,
like <TT>!</TT>
and the unary <TT>-</TT>, <TT>&amp;</TT>, and <TT>*</TT> operators.)
Complementing a number means to change all the
0 bits to 1
and all the 1s to 0s.
For example, assuming 16-bit integers, <TT>~0x56</TT> is <TT>0xffa9</TT>:
<pre>
	~ 0 0 0 0 0 0 0 0 0 1 0 1 0 1 1 0
	  -------------------------------
	  1 1 1 1 1 1 1 1 1 0 1 0 1 0 0 1
</pre>
</p><p>The <TT>&lt;&lt;</TT> operator
shifts its first operand left by a number of bits
given by its second operand,
filling in new 0 bits at the right.
Similarly, the <TT>&gt;&gt;</TT> operator
shifts its first operand right.
If the first operand is <TT>unsigned</TT>,
<TT>&gt;&gt;</TT> fills in 0 bits from the left,
but if the first operand is signed,
<TT>&gt;&gt;</TT> might fill in 1 bits if the high-order bit was already 1.
(Uncertainty like this
is one reason why it's usually a good idea
to use all <TT>unsigned</TT> operands
when working with the bitwise operators.)
For example, <TT>0x56 &lt;&lt; 2</TT> is <TT>0x158</TT>:
<pre>
	      0 1 0 1 0 1 1 0 &lt;&lt; 2
	  -------------------
	  0 1 0 1 0 1 1 0 0 0
</pre>
And <TT>0x56 &gt;&gt; 1</TT> is <TT>0x2b</TT>:
<pre>
	  0 1 0 1 0 1 1 0 &gt;&gt; 1
	  ---------------
	    0 1 0 1 0 1 1
</pre>
For both of the shift operators,
bits that scroll ``off the end'' are discarded;
they don't wrap around.
(Therefore, <TT>0x56 &gt;&gt; 3</TT> is <TT>0x0a</TT>.)
</p><p>The bitwise operators will make more sense
if we take a look at some of the ways they're typically used.
We can use <TT>&amp;</TT> to test if a certain bit is 1 or not.
For example, <TT>0x56 &amp; 0x40</TT> is <TT>0x40</TT>,
but <TT>0x32 &amp; 0x40</TT> is <TT>0x00</TT>:
<pre>
	  0 1 0 1 0 1 1 0	  0 0 1 1 0 0 1 0
	&amp; 0 1 0 0 0 0 0 0	&amp; 0 1 0 0 0 0 0 0
	  ---------------	  ---------------
	  0 1 0 0 0 0 0 0	  0 0 0 0 0 0 0 0
</pre>
Since any nonzero result is considered ``true'' in C,
we can use an expression involving <TT>&amp;</TT> directly
to test some condition,
for example:
<pre>
	if(x &amp; 0x04)
		<I>do something</I> ;
</pre>
(If we didn't like testing against the bitwise result,
we could equivalently say
<TT>if((x &amp; 0x04) != 0)</TT> .
The extra parentheses are important, as we'll explain below.)
</p><p>Notice that
the value <TT>0x40</TT>
has exactly one 1 bit in its binary representation,
which makes it useful for testing
for the presence of a certain bit.
Such a value
is often called a <dfn>bit mask</dfn>.
Often, we'll define a series of bit masks,
all targeting different bits,
and then treat a single integer value as a set of <dfn>flags</dfn>.
A ``flag'' is an on-off, yes-no condition,
so we only need one bit to record it, not the 16 or 32 bits
(or more) of an <TT>int</TT>.
Storing a set of flags in a single <TT>int</TT>
does more than just save space,
it also makes it convenient to assign a set of flags all at once
from one flag variable to another,
using the conventional assignment operator <TT>=</TT>.
For example, if we made these definitions:
<pre>
	#define DIRTY	0x01
	#define OPEN	0x02
	#define VERBOSE	0x04
	#define RED	0x08
	#define SEASICK	0x10
</pre>
we would have set up 5 different bits
as keeping track of those 5 different conditions
(``dirty,'' ``open,'' etc.).
If we had a variable
<pre>
	unsigned int flags;
</pre>
which contained a set of these flags,
we could write tests like
<pre>
	if(flags &amp; DIRTY)
		{ /* code for dirty case */ }
</pre>
<pre>
	if(!(flags &amp; OPEN))
		{ /* code for closed case */ }
</pre>
<pre>
	if(flags &amp; VERBOSE)
		{ /* code for verbose case */ }
	else	{ /* code for quiet case */ }
</pre>
A condition like <TT>if(flags &amp; DIRTY)</TT>
can be read as
``if the <TT>DIRTY</TT> bit is on''.
</p><p>These bitmasks would also be useful for <em>setting</em> the flags.
To ``turn on the <TT>DIRTY</TT> bit,''
we'd say
<pre>
	flags = flags | DIRTY;		/* set DIRTY bit */
</pre>
How would we ``turn off'' a bit?
The way to do it is to leave on every bit but the one we're turning off,
if they were on already.
We do this with the <TT>&amp;</TT> and <TT>~</TT> operators:
<pre>
	flags = flags &amp; ~DIRTY;		/* clear DIRTY bit */
</pre>
This may be easier to see if we look at it in binary.
If the <TT>DIRTY</TT>, <TT>RED</TT>, and <TT>SEASICK</TT> bits
were already on,
<TT>flags</TT> would be <TT>0x19</TT>, and we'd have
<pre>
	  0 0 0 1 1 0 0 1
	&amp; 1 1 1 1 1 1 1 0
	  ---------------
	  0 0 0 1 1 0 0 0
</pre>
As you can see,
both the <TT>|</TT> operator when turning bits on
and the <TT>&amp;</TT> (plus <TT>~</TT>) operator when turning bits off
have no effect if the targeted bit were already on or off, respectively.
</p><p>The definition of the exclusive-OR operator
means that you can use it to <dfn>toggle</dfn> a bit,
that is,
to turn it to 1 if it was 0 and to 0 if it was one:
<pre>
	flags = flags ^ VERBOSE;	/* toggle VERBOSE bit */
</pre>
</p><p>It's common to use the ``<I>op</I><TT>=</TT>'' shorthand forms
when doing all of these operations:
<pre>
	flags |= DIRTY;			/* set DIRTY bit */
	flags &amp;= ~OPEN;			/* clear OPEN bit */
	flags ^= VERBOSE;		/* toggle VERBOSE bit */
</pre>
</p><p>We can also use the bitwise operators to extract
subsets of bits from the middle of
an integer.
For example,
to extract the second-to-last hexadecimal ``digit,''
we could use
<pre>
	(i &amp; 0xf0) &gt;&gt; 4
</pre>
If <TT>i</TT> was <TT>0x56</TT>, we have:
<pre>
	     i		  0 1 0 1 0 1 1 0
	&amp; 0x56		&amp; 1 1 1 1 0 0 0 0
			  ---------------
			  0 1 0 1 0 0 0 0
</pre>
and shifting this result right by 4 bits
gives us <TT>0 1 0 1</TT>,
or 5,
as we wished.
Replacing
(or overwriting)
a subset of bits
is a bit more complicated;
we must first use <TT>&amp;</TT> and <TT>~</TT>
to clear all of the destination bits,
then use <TT>&lt;&lt;</TT> and <TT>|</TT> to ``OR in''
the new bits.
For example,
to replace that second-to-last hexadecimal digit
with some new bits,
we might use:
<pre>
	(i &amp; ~0xf0) | (newbits &lt;&lt; 4)
</pre>
If <TT>i</TT> was still <TT>0x56</TT> and <TT>newbits</TT> was 6,
this would give us
<pre>
	      i			  0 1 0 1 0 1 1 0
	&amp; ~0xf0			&amp; 0 0 0 0 1 1 1 1
				  ---------------
				  0 0 0 0 0 1 1 0
	| (newbits &lt;&lt; 4)	| 0 1 1 0 0 0 0 0
				  ---------------
				  0 1 1 0 0 1 1 0
</pre>
resulting in <TT>0x66</TT>, as desired.
</p><p>We've been using extra parentheses
in several of these bitwise expressions
because it turns out that
(for the usual, hoary sort of ``historical reasons'')
the precedence of
the bitwise <TT>&amp;</TT>, <TT>|</TT>, and <TT>^</TT>
operators is low, usually lower than we'd want.
(The reason that they're low is that, once upon a time,
C didn't have the logical operators <TT>&amp;&amp;</TT> and <TT>||</TT>,
and the bitwise operators <TT>&amp;</TT> and <TT>|</TT> did double duty.)
However, since the precedence of <TT>&amp;</TT> and <TT>|</TT>
(and <TT>^</TT>)
is lower than <TT>==</TT>, <TT>!=</TT>,
<TT>&lt;&lt;, and </TT><TT>&gt;&gt;</TT>,
expressions like
<pre>
	if(a &amp; 0x04 != 0)	/* WRONG */
</pre>
and
<pre>
	i &amp; 0xf0 &gt;&gt; 4		/* WRONG */
</pre>
would <em>not</em> work as desired;
these last two would be equivalent to
<pre>
	if(a &amp; (0x04 != 0))
	i &amp; (0xf0 &gt;&gt; 4)
</pre>
and would not do the bit test or subset extraction that we wanted.
</p><p>[The rest of this section is somewhat advanced and may be skipped.]
</p><p>Because of the nature of base-2 arithmetic,
it turns out that shifting left and shifting right
are equivalent to multiplying and dividing by two.
These operations are equivalent for the same reason that
tacking zeroes on to the right of a number in base 10
is the same as multiplying by 10,
and deleting digits from the right is the same as dividing by 10.
You can convince yourself that
<TT>0x56 &lt;&lt; 2</TT>
is the same as <TT>0x56 * 4</TT>,
and that
<TT>0x56 &gt;&gt; 1</TT>
is the same as <TT>0x56 / 2</TT>.
It's also the case that masking off all but the low-order bits
is the same as taking a remainder;
for example,
<TT>0x56 &amp; 0x07</TT>
is the same as <TT>0x56 % 8</TT>.
Some programmers therefore use
<TT>&lt;&lt;</TT>, <TT>&gt;&gt;</TT>, and <TT>&amp;</TT>
in preference to
<TT>*</TT>, <TT>/</TT>, and <TT>%</TT>
when powers of two are involved,
on the grounds that the bitwise operators are ``more efficient.''
Usually it isn't worth worrying about this, though,
because most compilers are smart enough
to perform these optimizations anyway
(that is, if you write <TT>x * 4</TT>,
the compiler might generate a left shift instruction all by itself),
they're not always as readable,
and they're not always correct for negative numbers.
</p><p>The issue of negative numbers, by the way,
explains why the right-shift operator <TT>&gt;&gt;</TT>
is not precisely defined
when the high-order bit of the value being shifted is 1.
For signed values,
if the high-order bit is a 1,
the number is negative.
(This is true for 1's complement, 2's complement,
and sign-magnitude representations.)
If you were using a right shift to implement division,
you'd want a negative number to stay negative,
so on some computers,
under some compilers,
when you shift a signed value right
and the high-order bit is 1,
new
1 bits are shifted in at the left instead of 0s.
However, you can't depend on this,
because not all computers and compilers implement right shift this way.
In any case,
shifting negative numbers to the right
(even if the high-order 1 bit propagates)
gives you an incorrect answer if there's a remainder involved:
in 2's complement, 16-bit arithmetic, -15 is <TT>0xfff1</TT>,
so <TT>-15 &gt;&gt; 1</TT> might give you 
<TT>0xfff8</TT>shifted
which is -8.
But integer division is supposed to discard the remainder,
so <TT>-15 / 2</TT> would have given you -7.
(If you're having trouble seeing the way the shift worked,
<TT>0xfff1</TT> is 1111111111110001<tt>&lt;sub&gt;</tt>2<tt>&lt;/sub&gt;</tt> and
<TT>0xfff8</TT> is 1111111111111000<tt>&lt;sub&gt;</tt>2<tt>&lt;/sub&gt;</tt>.
The low-order 1 bit got shifted off to the right,
but because the high-order bit was 1,
a 1 got shifted in at the left.)
</p><hr>
<p>
Read sequentially:
<a href="sx4b.html" rev=precedes>prev</a>
<a href="sx4bb.html" rel=precedes>next</a>
<a href="sx4b.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1996-1999
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
